package main

import (
	"fmt"
	"io/ioutil"
	"strconv"
	"strings"
)

const (
	RESULT_BAD_MAGICIAN      = iota
	RESULT_FOUND             = iota
	RESULT_VOLUNTEER_CHEATED = iota
)

func solve(firstCards []int, secondCards []int) (int, int) {
	// map[card_number] = true
	lookup := make(map[int]bool)
	for _, i := range firstCards {
		lookup[i] = true
	}

	duplicateCount := 0
	possibleCard := 0
	for _, i := range secondCards {
		if _, ok := lookup[i]; ok {
			if duplicateCount == 0 {
				duplicateCount = 1
				possibleCard = i
			} else {
				return 0, RESULT_BAD_MAGICIAN
			}
		}
	}

	if duplicateCount == 1 {
		return possibleCard, RESULT_FOUND
	} else {
		return 0, RESULT_VOLUNTEER_CHEATED
	}
}

func main() {
	content, _ := ioutil.ReadFile("A-small-practice.in")
	lines := strings.Split(string(content), "\n")

	caseNum, _ := strconv.Atoi(lines[0])

	for i := 0; i < caseNum; i++ {
		firstChoiceRowNum, _ := strconv.Atoi(lines[i*10+1])
		secondChoiceRowNum, _ := strconv.Atoi(lines[i*10+6])

		firstChoiceRow := strings.Split(lines[i*10+firstChoiceRowNum+1], " ")
		secondChoiceRow := strings.Split(lines[i*10+secondChoiceRowNum+6], " ")

		firstCards := make([]int, 0, len(firstChoiceRow))
		secondCards := make([]int, 0, len(secondChoiceRow))

		for _, v := range firstChoiceRow {
			n, _ := strconv.Atoi(v)
			firstCards = append(firstCards, n)
		}
		for _, v := range secondChoiceRow {
			n, _ := strconv.Atoi(v)
			secondCards = append(secondCards, n)
		}

		card, status := solve(firstCards, secondCards)

		switch status {
		case RESULT_FOUND:
			fmt.Printf("Case #%d: %d\n", i+1, card)
		case RESULT_BAD_MAGICIAN:
			fmt.Printf("Case #%d: Bad magician!\n", i+1)
		case RESULT_VOLUNTEER_CHEATED:
			fmt.Printf("Case #%d: Volunteer cheated!\n", i+1)
		}
	}
}
