package main

import (
	"fmt"
	"io/ioutil"
	"strconv"
	"strings"
)

func solve(c float64, f float64, x float64) float64 {
	// map[farm count] = total cost time
	buildTimeLookup := make(map[int]float64)
	rateLookup := make(map[int]float64)
	totalTimeLookup := make(map[int]float64)

	farmCountToBeBuilt := 0

	buildTimeLookup[farmCountToBeBuilt] = 0
	rateLookup[farmCountToBeBuilt] = 2
	totalTimeLookup[farmCountToBeBuilt] = buildTimeLookup[farmCountToBeBuilt] + (x / rateLookup[farmCountToBeBuilt])

	for {
		farmCountToBeBuilt++

		buildTimeLookup[farmCountToBeBuilt] = buildTimeLookup[farmCountToBeBuilt-1] + (c / rateLookup[farmCountToBeBuilt-1])
		rateLookup[farmCountToBeBuilt] = rateLookup[farmCountToBeBuilt-1] + f
		totalTimeLookup[farmCountToBeBuilt] = buildTimeLookup[farmCountToBeBuilt] + (x / rateLookup[farmCountToBeBuilt])

		if totalTimeLookup[farmCountToBeBuilt-1] <= totalTimeLookup[farmCountToBeBuilt] {
			return totalTimeLookup[farmCountToBeBuilt-1]
		}
	}
}

func main() {
	content, _ := ioutil.ReadFile("B-large-practice.in")
	lines := strings.Split(string(content), "\n")

	caseNum, _ := strconv.Atoi(lines[0])

	for i := 0; i < caseNum; i++ {
		line := strings.Split(lines[i+1], " ")

		c, _ := strconv.ParseFloat(line[0], 64)
		f, _ := strconv.ParseFloat(line[1], 64)
		x, _ := strconv.ParseFloat(line[2], 64)

		fmt.Printf("Case #%d: %.7f\n", i+1, solve(c, f, x))
	}
}
